package com.huaching;

import com.alibaba.fastjson.JSON;
import com.huaching.util.HttpUtil;
import com.huaching.util.MD5Util;
import org.apache.commons.lang3.StringUtils;

import java.util.*;

public class Main {

    public static void main(String[] args) {
        // appId
        String appId = "test_open_id";
        // 六位随机数
        Integer nonce = (int) ((Math.random() * 9 + 1) * 100000);
        // 时间戳，单位：秒
        long curTime = System.currentTimeMillis() / 1000;
        // 用户密钥
        String clientSecret = "pmcsfqryxmfhtejxuhdtwkzoopwmd";
        // 业务参数，json
        String bizContent = "{\"parkCode\": \"731\",\"spaceCode\": \"008\",\"status\": 2}";
        // 签名
        String sign = "";

        TreeMap<String, String> params = new TreeMap<>();
        params.put("appId", appId);
        params.put("nonce", nonce.toString());
        params.put("curTime", curTime + "");
        params.put("bizContent", bizContent);

        // 生成签名
        TreeMap<String, String> tree = new TreeMap<>(params);
        tree.put("clientSecret", clientSecret);
        StringBuffer str = new StringBuffer();
        tree.forEach((key, value) -> Optional.ofNullable(value).filter(v -> !StringUtils.isEmpty(v)).map(v -> str.append(key).append("=").append(v)));
        String base64Sign = Base64.getEncoder().encodeToString(str.toString().getBytes());
        sign = MD5Util.md5(base64Sign);

        // 请求api
        Map<String, String> httpParams = new HashMap<>(16);
        httpParams.put("appId", appId);
        httpParams.put("nonce", nonce.toString());
        httpParams.put("curTime", curTime + "");
        httpParams.put("bizContent", bizContent);
        httpParams.put("sign", sign);

        Map<String, String> header = new HashMap<>(16);
        header.put("Content-Type", "application/json");

        String respone = HttpUtil.putHeaderString("https://testing.huaching.com/ths_proxy/openapi/openApi/updateCarLockStatus", header, JSON.toJSONString(httpParams));
        System.out.println(respone);
    }
}
